package lcsb.mapviewer.model.map.graph;

import org.apache.log4j.Logger;

import lcsb.mapviewer.common.Comparator;
import lcsb.mapviewer.common.Configuration;
import lcsb.mapviewer.common.comparator.StringComparator;

/**
 * Comparator for {@link DataMiningSet} class.
 * 
 * @author Piotr Gawron
 * 
 */
public class DataMiningSetComparator extends Comparator<DataMiningSet> {
  /**
   * Default class logger.
   */
  private Logger logger = Logger.getLogger(DataMiningSetComparator.class);

  /**
   * Epsilon value used for comparison of doubles.
   */
  @SuppressWarnings("unused")
  private double epsilon;

  /**
   * Constructor that requires {@link #epsilon} parameter.
   * 
   * @param epsilon
   *          {@link #epsilon}
   */
  public DataMiningSetComparator(double epsilon) {
    super(DataMiningSet.class, true);
    this.epsilon = epsilon;
  }

  /**
   * Default constructor.
   */
  public DataMiningSetComparator() {
    this(Configuration.EPSILON);
  }

  @Override
  protected int internalCompare(DataMiningSet arg0, DataMiningSet arg1) {
    StringComparator stringComparator = new StringComparator();

    if (stringComparator.compare(arg0.getName(), arg1.getName()) != 0) {
      logger.debug("Name different: " + arg0.getName() + ", " + arg1.getName());
      return stringComparator.compare(arg0.getName(), arg1.getName());
    }

    return 0;
  }

}
