package lcsb.mapviewer.model.map.graph;

/**
 * Type of the data mining element.
 * 
 * @author Piotr Gawron
 * 
 */
public enum DataMiningType {
	
	/**
	 * Data minig entry from text mining.
	 */
	TEXT_MINING(null, "Text mining"),
	
	/**
	 * Data mining entry from pathvar.
	 */
	STRUCTURE_ANALYSIS("http://pathvar.embl.de/", "Structure analysis"),

	/**
	 * Unknown data mining entry type.
	 */
	UNKNOWN(null, "Unknown");

	/**
	 * Link to the tool which was used to obtain the results.
	 */
	private String	source			= "";
	/**
	 * Common name of the data mining source.
	 */
	private String	commonName	= "";

	/**
	 * Default constructor.
	 * 
	 * @param source
	 *          {@link #source}
	 * @param commonName
	 *          {@link #commonName}
	 */
	DataMiningType(String source, String commonName) {
		this.source = source;
		this.commonName = commonName;
	}

	/**
	 * @return the source
	 * @see #source
	 */
	public String getSource() {
		return source;
	}

	/**
	 * @return the commonName
	 * @see #commonName
	 */
	public String getCommonName() {
		return commonName;
	}

}
