package lcsb.mapviewer.model.map.graph;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import org.apache.commons.lang3.SerializationUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelFullIndexed;

public class DataMiningSetTest {

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testSerialization() {
		try {
			SerializationUtils.serialize(new DataMiningSet());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testConstructor() {
		try {
			DataMiningSet dms = new DataMiningSet();
			DataMiningSet dms3 = new DataMiningSet(dms);
			assertNull(dms3.getInputData());
			dms.setInputData(new byte[] { 3 });

			DataMiningSet dms2 = new DataMiningSet(dms);
			assertArrayEquals(dms2.getInputData(), dms.getInputData());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetters() {
		try {
			DataMiningSet dms = new DataMiningSet();
			String description = "desc";
			String name = "n";
			int id = 7;
			DataMiningType type = DataMiningType.STRUCTURE_ANALYSIS;
			String source = "src";

			Model model = new ModelFullIndexed(null);

			dms.setDescription(description);
			dms.setId(id);
			dms.setModel(model);
			dms.setModel(model.getModelData());
			dms.setName(name);
			dms.setSource(source);
			dms.setType(type);

			assertEquals(description, dms.getDescription());
			assertEquals(id, dms.getId());
			assertEquals(model.getModelData(), dms.getModel());
			assertEquals(name, dms.getName());
			assertEquals(source, dms.getSource());
			assertEquals(type, dms.getType());

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}
}
