package lcsb.mapviewer.model.map.graph;

import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.SerializationUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import lcsb.mapviewer.model.map.MiriamData;
import lcsb.mapviewer.model.map.species.Element;
import lcsb.mapviewer.model.map.species.GenericProtein;

public class DataMiningTest {

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testSerialization() {
		try {
			SerializationUtils.serialize(new DataMining());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetters() {
		try {
			DataMining dm = new DataMining();
			String description = "xdg";
			Element element = new GenericProtein("id");
			Integer id = 61;
			List<MiriamData> references = new ArrayList<>();
			List<MiriamData> suggestedConnections = new ArrayList<>();
			DataMiningType type = DataMiningType.STRUCTURE_ANALYSIS;

			dm.setDescription(description);
			assertEquals(description, dm.getDescription());
			dm.setElement(element);
			assertEquals(element, dm.getElement());
			dm.setId(id);
			assertEquals(id, dm.getId());
			dm.setReferences(references);
			assertEquals(references, dm.getReferences());
			dm.setSuggestedConnections(suggestedConnections);
			assertEquals(suggestedConnections, dm.getSuggestedConnections());
			dm.setType(type);
			assertEquals(type, dm.getType());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testAddReference() {
		try {
			DataMining dm = new DataMining();
			List<MiriamData> references = new ArrayList<>();
			references.add(new MiriamData());
			references.add(new MiriamData());
			dm.addReferences(references);
			assertEquals(2, dm.getReferences().size());
			dm.addReference(new MiriamData());
			assertEquals(3, dm.getReferences().size());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testAddSuggestedConnections() {
		try {
			DataMining dm = new DataMining();
			dm.addSuggestedConnection(new MiriamData());
			assertEquals(1, dm.getSuggestedConnections().size());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}
}
