package lcsb.mapviewer.model.map.species;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.fail;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.SerializationUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import lcsb.mapviewer.common.exception.NotImplementedException;
import lcsb.mapviewer.model.map.species.field.AntisenseRnaRegion;

public class AntisenseRnaTest {

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testSerialization() {
		try {
			SerializationUtils.serialize(new AntisenseRna());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testConstructor1() {
		try {
			AntisenseRna original = new AntisenseRna();
			original.addRegion(new AntisenseRnaRegion());
			AntisenseRna aRna = new AntisenseRna(original);
			assertNotNull(aRna);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetters() {
		try {
			AntisenseRna aRna = new AntisenseRna("id");
			assertNotNull(aRna.getStringType());

			List<AntisenseRnaRegion> regions = new ArrayList<>();

			aRna.setRegions(regions);

			assertEquals(regions, aRna.getRegions());
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testCopy() {
		try {
			AntisenseRna aRna = new AntisenseRna().copy();
			assertNotNull(aRna);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testInvalidCopy() {
		try {
			AntisenseRna element = Mockito.spy(AntisenseRna.class);
			element.copy();
			fail("Exception expected");
		} catch (NotImplementedException e) {
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

}
